# perl

my $msys = 1; #($ENV{TERM} eq "msys")?1:0;

foreach my $arg (@ARGV) 
{
  open(LST,"<$arg.lst") or print "Doh - couldn't load $arg\n";

  my $lines = "";
  my @drivers = "";
  my $def_tiny_options = "{22050,2,1,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0}";
  my %forced_tiny_options;

  while (<LST>)
  {
    $_ =~ s/\s$//;

    # Need a mechanism to allow for forced tiny_option values
    # these lines don't need to end up in the .mak

    if ($_ =~ /^#\s*DEF_TINY_OPTIONS=(.*)$/i) 
    {
      $def_tiny_options = $1;
    }
    elsif ($_ =~ /^#\s*(.*)_TINY_OPTIONS=(.*)$/i)
    {
      $forced_tiny_options{$1} = $2;
    }
    else
    {
      $lines .= $_;

      $lines.="\n" if ($msys == 1);
    }

    while($_ =~ /\/(drivers\/\S+)\.o/g) 
    {
      push(@drivers,$1);
    }
  }

  close(LST);

  $lines =~ s/\r//;

  my %games = ();

  foreach my $driver (@drivers)
  {
    open(DRV,"<src/$driver.c");

    while(<DRV>)
    {
      if ($_ =~ /^\s*GAME(B|BX|X|_S|_VS|_QS)*\s*\((.*)\)/) 
      {
        (@parts) = split(/\s*,\s*/,$2);

        print "PART:$parts[1]\n";

        $games{$parts[8]} = $parts[1];
      }
    }

    close(DRV);
  }

  $tiny_names = "COREDEFS += -DTINY_NAME=\"";
  $tiny_pointers = "COREDEFS += -DTINY_POINTER=\"";
  $tiny_options = "COREDEFS += -DTINY_OPTIONS=\"$def_tiny_options\"";

  my $menu_max = 10; # Some HEADROOM

  foreach my $game (sort keys(%games))
  {
    $tiny_names .= "driver_$games{$game},";
    $tiny_pointers .="&driver_$games{$game},";

    #if (exists($forced_tiny_options{$games{$game}}))
    #{
    #  $tiny_options .= "$forced_tiny_options{$games{$game}},";
    #}
    #else
    #{
    #  $tiny_options .= "$def_tiny_options,";
    #}

    $menu_max++;
  }

  chop($tiny_names);
  chop($tiny_pointers);
  chop($tiny_options);

  open(MAK,">$arg.mak");

  print MAK "COREDEFS += -DTINY_COMPILE=1\n";
  print MAK "$tiny_names\"\n";
  print MAK "$tiny_pointers\"\n";
  print MAK "$tiny_options\"\n";
  print MAK "COREDEFS += -DMENU_MAX=$menu_max\n";
  print MAK "$lines";

  close(MAK);
}
