#define MAIM_OPTIONS      20
#define MAIM_OPTIONS_USED 15

void set_brightness(int _brightness);

#ifdef WT_PROFILE
#ifdef WT_PROFILE_GLOBALS
unsigned long totalticks[100] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned long totalinstances[100] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned long startticks[100] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned long cycles = 0;
#else
extern unsigned long totalticks[100];
extern unsigned long totalinstances[100];
extern unsigned long startticks[100];
extern unsigned long cycles;
#endif

#include <time.h>

#define WT_PENTRY(ctr)                                     \
{                                                          \
  struct timeval tv;                                       \
  gettimeofday(&tv, 0);                                    \
  startticks[(ctr)] = tv.tv_sec * 100000 + tv.tv_usec/10;  \
}
  
#define WT_PEXIT(ctr)                                                               \
{                                                                                   \
  struct timeval tv;                                                                \
  gettimeofday(&tv, 0);                                                             \
  if (startticks[(ctr)])                                                            \
  {                                                                                 \
    totalticks[(ctr)] += (tv.tv_sec * 100000 + tv.tv_usec/10) - startticks[(ctr)];  \
    totalinstances[(ctr)]+=1;                                                       \
  }                                                                                 \
}

#define WT_PDISPLAY_AFTER_CYCLES 100

#if 0
#define WT_PDISPLAY                                                 \
if (!(++cycles % WT_PDISPLAY_AFTER_CYCLES))                         \
{                                                                   \
  int i;                                                            \
  for(i=0;i<100;i++)                                                \
    if (totalinstances[i])                                          \
      printf("%d %lu %lu (avg=%lu)\n",i,                            \
              totalticks[i],                                        \
              totalinstances[i],                                    \
              totalinstances[i]?totalticks[i]/totalinstances[i]:0); \
} 
#else
#define WT_PDISPLAY                               \
if (!(++cycles % WT_PDISPLAY_AFTER_CYCLES))       \
{                                                 \
  uint32 fp=dcload_open("PROFILE.txt", O_APPEND); \
  if (fp)                                         \
  {                                               \
    int i;                                        \
    char szText[256];                             \
    for(i=0;i<100;i++)                            \
    {                                             \
      if (totalinstances[i])                      \
      {                                           \
        sprintf(szText,"%d %lu %lu (avg=%lu)\n",i,  \
                totalticks[i],                      \
                totalinstances[i],                  \
                totalinstances[i]?totalticks[i]/totalinstances[i]:0); \
        dcload_write(fp,&szText,strlen(szText));    \
      }                                             \
    }                                             \
    dcload_close(fp);                             \
  }                                               \
  else                                            \
    printf("dcload_open failed\n");               \
}
#endif 
#else
#define WT_PENTRY(ctr)
#define WT_PEXIT(ctr)
#define WT_PDISPLAY
#endif

